



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Quartz_简单使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Quartz_简单使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-24 05:55:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>第一步：安装</h2>
<p>新建一个QuartzDemo项目后,安装下面的程序包</p>
<ul><li><code>Install-Package Quartz</code></li>
<li><code>Install-Package Common.Logging.Log4Net1211</code></li>
<li><code>Install-Package&nbsp;log4net</code></li>
<li><code>Install-Package&nbsp;<code>Topshelf</code></code></li>
<li><code>Install-Package Topshelf.Log4Net</code></li></ul>
<p>Quartz依赖Common.Logging和Common.Logging.Log4Net1211，又因为Log4Net是比较标准的日志工具，因此我们一般都会安装<code>log4net</code>，另外定时作业一般都允许在后台服务中，因此我们也安装了Topshelf。</p>
<h2>第二步：实现IJob</h2>
<p>TestJob.cs 实现IJob，在Execute方法里编写要处理的业务逻辑，系统就会按照Quartz的配置，定时处理。</p>
<div>
<div>
<pre class="prettyprint linenums">using log4net;<br />
using Quartz;<br />
using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Threading.Tasks;

namespace QuartzDemo.QuartzJobs<br />
{<br />
    public sealed class TestJob : IJob<br />
    {<br />
        private readonly ILog _logger = LogManager.GetLogger(typeof(TestJob));

        public void Execute(IJobExecutionContext context)<br />
        {<br />
            _logger.InfoFormat("TestJob测试");<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<h2>第三步：使用Topshelf调度任务</h2>
<div>
<div>
<pre class="prettyprint linenums">using Quartz;<br />
using Quartz.Impl;<br />
using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Threading.Tasks;<br />
using Topshelf;

namespace QuartzDemo<br />
{<br />
    public sealed class ServiceRunner : ServiceControl, ServiceSuspend<br />
    {<br />
        private readonly IScheduler scheduler;

        public ServiceRunner()<br />
        {<br />
            scheduler = StdSchedulerFactory.GetDefaultScheduler();<br />
        }

        public bool Start(HostControl hostControl)<br />
        {<br />
            scheduler.Start();<br />
            return true;<br />
        }

        public bool Stop(HostControl hostControl)<br />
        {<br />
            scheduler.Shutdown(false);<br />
            return true;<br />
        }

        public bool Continue(HostControl hostControl)<br />
        {<br />
            scheduler.ResumeAll();<br />
            return true;<br />
        }

        public bool Pause(HostControl hostControl)<br />
        {<br />
            scheduler.PauseAll();<br />
            return true;<br />
        }

    }<br />
}</pre>
</div>
<p>ServiceRunner.cs</p></div>
<h2>第四步：程序入口</h2>
<div>
<div>
<pre class="prettyprint linenums">namespace QuartzDemo<br />
{<br />
    class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            log4net.Config.XmlConfigurator.ConfigureAndWatch(new FileInfo(AppDomain.CurrentDomain.BaseDirectory + "log4net.config"));<br />
            HostFactory.Run(x =&gt;<br />
            {<br />
                x.UseLog4Net();

                x.Service&lt;ServiceRunner&gt;();

                x.SetDescription("QuartzDemo服务描述");<br />
                x.SetDisplayName("QuartzDemo服务显示名称");<br />
                x.SetServiceName("QuartzDemo服务名称");

                x.EnablePauseAndContinue();<br />
            });<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<h2>第五步：配置quartz.config、quartz_jobs.xml、log4net.config</h2>
<p><strong>说明：这三个文件，分别选中&rarr;右键属性&rarr;复制到输入目录设为：始终复制</strong></p>
<div>
<div>
<pre class="prettyprint linenums"># You can configure your scheduler in either &lt;quartz&gt; configuration section<br />
# or in quartz properties file<br />
# Configuration section has precedence

quartz.scheduler.instanceName = QuartzTest

# configure thread pool info<br />
quartz.threadPool.type = Quartz.Simpl.SimpleThreadPool, Quartz<br />
quartz.threadPool.threadCount =<br />
quartz.threadPool.threadPriority = Normal

# job initialization plugin handles our xml reading, without it defaults are used<br />
quartz.plugin.xml.type = Quartz.Plugin.Xml.XMLSchedulingDataProcessorPlugin, Quartz<br />
quartz.plugin.xml.fileNames = ~/quartz_jobs.xml

# export this server to remoting context<br />
#quartz.scheduler.exporter.type = Quartz.Simpl.RemotingSchedulerExporter, Quartz<br />
#quartz.scheduler.exporter.port =<br />
#quartz.scheduler.exporter.bindName = QuartzScheduler<br />
#quartz.scheduler.exporter.channelType = tcp<br />
#quartz.scheduler.exporter.channelName = httpQuartz</pre>
</div>
<p>quartz.config</p></div>
<div>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;

&lt;!-- This file contains job definitions in schema version 2.0 format --&gt;

&lt;job-scheduling-data xmlns="http://quartznet.sourceforge.net/JobSchedulingData" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="2.0"&gt;

  &lt;processing-directives&gt;<br />
    &lt;overwrite-existing-data&gt;true&lt;/overwrite-existing-data&gt;<br />
  &lt;/processing-directives&gt;

  &lt;schedule&gt;

    &lt;!--TestJob测试 任务配置--&gt;<br />
    &lt;job&gt;<br />
      &lt;name&gt;TestJob&lt;/name&gt;<br />
      &lt;group&gt;Test&lt;/group&gt;<br />
      &lt;description&gt;TestJob测试&lt;/description&gt;<br />
      &lt;job-type&gt;QuartzDemo.QuartzJobs.TestJob,QuartzDemo&lt;/job-type&gt;<br />
      &lt;durable&gt;true&lt;/durable&gt;<br />
      &lt;recover&gt;false&lt;/recover&gt;<br />
    &lt;/job&gt;<br />
    &lt;trigger&gt;<br />
      &lt;cron&gt;<br />
        &lt;name&gt;TestJobTrigger&lt;/name&gt;<br />
        &lt;group&gt;Test&lt;/group&gt;<br />
        &lt;job-name&gt;TestJob&lt;/job-name&gt;<br />
        &lt;job-group&gt;Test&lt;/job-group&gt;<br />
        &lt;start-time&gt;--22T00::+:&lt;/start-time&gt;<br />
        &lt;cron-expression&gt;/ * * * * ?&lt;/cron-expression&gt;<br />
      &lt;/cron&gt;<br />
    &lt;/trigger&gt;

  &lt;/schedule&gt;<br />
&lt;/job-scheduling-data&gt;</pre>
</div>
<p>quartz_jobs.xml</p></div>
<div>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8" ?&gt;<br />
&lt;configuration&gt;<br />
  &lt;configSections&gt;<br />
    &lt;section name="log4net" type="log4net.Config.Log4NetConfigurationSectionHandler, log4net"/&gt;<br />
  &lt;/configSections&gt;

  &lt;log4net&gt;<br />
    &lt;appender name="RollingLogFileAppender" type="log4net.Appender.RollingFileAppender"&gt;<br />
      &lt;!--日志路径--&gt;<br />
      &lt;param name= "File" value= "D:\App_Log\servicelog\"/&gt;<br />
      &lt;!--是否是向文件中追加日志--&gt;<br />
      &lt;param name= "AppendToFile" value= "true"/&gt;<br />
      &lt;!--log保留天数--&gt;<br />
      &lt;param name= "MaxSizeRollBackups" value= ""/&gt;<br />
      &lt;!--日志文件名是否是固定不变的--&gt;<br />
      &lt;param name= "StaticLogFileName" value= "false"/&gt;<br />
      &lt;!--日志文件名格式为:--.log--&gt;<br />
      &lt;param name= "DatePattern" value= "yyyy-MM-dd&amp;quot;.read.log&amp;quot;"/&gt;<br />
      &lt;!--日志根据日期滚动--&gt;<br />
      &lt;param name= "RollingStyle" value= "Date"/&gt;<br />
      &lt;layout type="log4net.Layout.PatternLayout"&gt;<br />
        &lt;param name="ConversionPattern" value="%d [%t] %-5p %c - %m%n %loggername" /&gt;<br />
      &lt;/layout&gt;<br />
    &lt;/appender&gt;

    &lt;!-- 控制台前台显示日志 --&gt;<br />
    &lt;appender name="ColoredConsoleAppender" type="log4net.Appender.ColoredConsoleAppender"&gt;<br />
      &lt;mapping&gt;<br />
        &lt;level value="ERROR" /&gt;<br />
        &lt;foreColor value="Red, HighIntensity" /&gt;<br />
      &lt;/mapping&gt;<br />
      &lt;mapping&gt;<br />
        &lt;level value="Info" /&gt;<br />
        &lt;foreColor value="Green" /&gt;<br />
      &lt;/mapping&gt;<br />
      &lt;layout type="log4net.Layout.PatternLayout"&gt;<br />
        &lt;conversionPattern value="%n%date{HH:mm:ss,fff} [%-5level] %m" /&gt;<br />
      &lt;/layout&gt;

      &lt;filter type="log4net.Filter.LevelRangeFilter"&gt;<br />
        &lt;param name="LevelMin" value="Info" /&gt;<br />
        &lt;param name="LevelMax" value="Fatal" /&gt;<br />
      &lt;/filter&gt;<br />
    &lt;/appender&gt;

    &lt;root&gt;<br />
      &lt;!--(高) OFF &gt; FATAL &gt; ERROR &gt; WARN &gt; INFO &gt; DEBUG &gt; ALL (低) --&gt;<br />
      &lt;level value="all" /&gt;<br />
      &lt;appender-ref ref="ColoredConsoleAppender"/&gt;<br />
      &lt;appender-ref ref="RollingLogFileAppender"/&gt;<br />
    &lt;/root&gt;<br />
  &lt;/log4net&gt;<br />
&lt;/configuration&gt;</pre>
</div>
<p>log4net.config</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390jgo8d.html">最新的 cocoaPods 安装方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwddzq.html">Android jar包的导出和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnw763q.html">SpringMVC&plus;Freemarker&plus;JSTL支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z6v1xq.html">sql server操作类（本人自己写的）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1yj72q.html">Unsupported major&period;minor version 51&period;0解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq12pd49.html">java&period;lang&period;ClassCastException&colon; com&period;sun&period;proxy&period;&dollar;Proxy32 cannot be cast to com&period;bkc&period;bpmp&period;core&period;cache&period;MemcachedManager</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93k5zrq.html">memcached命令行操作详解，命令选项的详细解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgvd39.html">pwnable&period;kr-fd</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952mee9.html">HTML页面放大镜效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1om7g8.html">i&plus;&plus; 与 &plus;&plus;i 的从字节码层面看二者的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xe1og9.html">Reverse Linked List II java</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okzzwx9.html">SQL Server 主动防止阻塞的 1 方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13dej9.html">实现将VirtualBox 虚拟机转换为KVM虚拟机的步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mr4148.html">Bootstrap Paginator分页插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kv5m29.html">c&num;计算datatable中某一列值的和</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj5j469.html">&lbrack;Selenium With C&num;学习笔记&rsqb; Lesson-01环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myyyn8.html">处理文本，提取数据的脚本-主要就是用sed</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo367dq.html">C&num;中的Infinity和NaN</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m15038.html">Ubuntu&lpar;Linux&rpar;下如何用源码文件安装软件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgpyp78.html">云计算之路-阿里云上-容器难容：容器服务故障以及自建 docker swarm 集群故障</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxd4r0e9.html">C语言开发的思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjx6ee9.html">Python使用map&comma;reduce高阶函数模拟实现Spark的reduceByKey算子功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4x6ne9.html">如何创建和还原SQL Server 2000数据库？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4xk2k9.html">redhat5 安装mysql 5&period;6</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rd63z8.html">Python基础知识：测试代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllxr7eq.html">使用sstream来进行类型转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllxr3kq.html">八皇后问题的Python实现和C&num;实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2x0opq.html">&lbrack;bug&rsqb; 验证selenium的显式和隐式等待而发现的一个低级错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o12mzeq.html">c&plus;&plus;11の多线程应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllxyexq.html">Linux（CentOS）上配置 SFTP（附解决Write failed&colon; Broken pipe Couldn&amp;&num;39&semi;t read packet&colon; Connection reset by peer）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
